"""
**Real** `Optional` type in `python`, not `@Nullable` annotation.

Home: https://baijifeilong.github.io/2022/01/09/ice-spring-real-optional/index.html

Github: https://github.com/baijifeilong/IceSpringRealOptional

PyPI: https://pypi.org/project/IceSpringRealOptional

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""

# Created by BaiJiFeiLong@gmail.com at 2022/1/10 16:56

from __future__ import annotations

from typing import Generic, Callable, Any

from IceSpringRealOptional.generics import T, U


class Just(Generic[T]):
    _value: T

    @classmethod
    def of(cls, value: T) -> Just[T]:
        just = cls()
        just._value = value
        return just

    def value(self) -> T:
        return self._value

    def apply(self, consumer: Callable[[T], Any]) -> Just[T]:
        consumer(self._value)
        return self

    def map(self, mapper: Callable[[T], U]) -> Just[U]:
        return Just.of(mapper(self._value))
